=== debian/changelog ===
kim-api (2.3.0-1ubuntu1) plucky; urgency=medium

  * Fix install file, which avoids the FTBFS.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 04 Mar 2025 10:55:01 -0600

kim-api (2.3.0-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:43:28 +0200

kim-api (2.3.0-1) unstable; urgency=medium

  * [8284c56] Update gitlab-ci.yml.
  * [851b3d7] Do not install extra license-file.
  * [bf15197] Override lintian error.
  * [782ac7d] New upstream version 2.3.0.

 -- Anton Gladky <gladk@debian.org>  Fri, 21 Oct 2022 22:10:31 +0200
